#include <iostream>
#include <pthread.h>
#include <sys/time.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/shm.h>

#include "SensorConfiguration.h"
#include "SensorCommunication.h"
#include "Motion.h"
#include "CNamedSemaphore.h"

#include "SensorTag.h"

using namespace std;

#define KEY 1000

/*
struct threadparam {
    Motion * mot;
    struct timespec sleep;
};

void t1sub(Motion* mot, SensorTag* q) {
    *mot = q->getMotion();
    mot->print();
}

void* t1(void *param) {

    set_cpu_affinity(0);

    struct threadparam * tp = (struct threadparam*) param;

    Motion *mot = tp->mot;

    SensorTag q;

    for (int i=0; i < 10000; i++) {
        t1sub(mot, &q);
//        nanosleep(&(tp->sleep), NULL);

        sched_yield();
    }


}


void t2sub(Motion* mot) {
    mot->acc.x=0;
    mot->acc.y=0;
    mot->acc.z=0;
    mot->gyro.x=0;
    mot->gyro.y=0;
    mot->gyro.z=0;
    mot->print();
}

void* t2(void *param) {

    set_cpu_affinity(0);

    struct threadparam * tp = (struct threadparam*) param;

    Motion *mot = tp->mot;

  //  usleep(duration);

    for (int i=0; i < 10000; i++) {
        t2sub(mot);
   //     usleep(duration);
//        nanosleep(&(tp->sleep), NULL);
        sched_yield();
    }

}

void init_thread(pthread_attr_t *attr) {

    pthread_attr_init(attr);
    pthread_attr_setschedpolicy(attr, SCHED_FIFO);
    struct sched_param prio;

    prio.__sched_priority = 10;
    pthread_attr_setschedparam(attr, &prio);

}
*/
// valid states for our two processes, we use the impicit ordering of values
// by an enum starting with the value 1
enum EProc_State {
    STATE_ACTIVE_CHILD = 1,
    STATE_ACTIVE_PARENT,
    STATE_TERMINATE
};

const char sem_name1[] = "/semaphore";
const char sem_name2[] = "/state";
CNamedSemaphore semaphore(sem_name1, 1);
CNamedSemaphore state(sem_name2, STATE_ACTIVE_CHILD);

#define NUMBER_OF_LOOPS     10

// function being executed as parent or as child process to perform ping pong
// between both processes
void pingpong(bool parent) {

    int i = 0;

    SensorTag q;

    Motion mot;

    while (1) {


        semaphore.decrement();
        int stateval = state.value();
        semaphore.increment();

        switch(stateval) {


            case STATE_ACTIVE_PARENT: {

                if (parent) {

                    semaphore.decrement();
                    cout << "Parent says:" << endl << flush;
                    mot = q.getMotion();
                    mot.print();
                    cout << "pong" << endl << flush;
                    state.decrement();
                    semaphore.increment();

                }

                break;

            }

            case STATE_ACTIVE_CHILD: {

                if (!parent) {
                    semaphore.decrement();
                    i++;
                    cout << "Child says:" << endl << flush;
                    mot = q.getMotion();
                    mot.print();
                    cout << "ping: " << i << endl << flush;
                    state.increment();
                    if (i>=NUMBER_OF_LOOPS) {
                        state.increment();
                        semaphore.increment();
//                        return;
                    }
                    semaphore.increment();
                }
                break;

            }

            case STATE_TERMINATE: {
                if (parent) {

                    cout << "Parent says: TIME TO TERMINATE!" << endl << flush;

                }

                return;
            }
        }
    }
}

int main()
{

    Motion *mot;

    mot = new Motion;

    SensorTag q;
    q.setAddr("24:71:89:E8:33:83");

    int shm_size = 4096;
//    int shmid = shmget(KEY, shm_size, 0666|IPC_CREAT);


    pid_t pid = fork();
    if (pid > 0) {
        cout << "FORKED  PARENT" << endl;
        pingpong(true);

    } else if (pid == 0) {
        cout << "FORKED  CHILD" << endl;
        pingpong(false);
    }

    return 0;
}
