#include "SensorTag.h"

SensorTag::SensorTag()
{
    //ctor
}

SensorTag::~SensorTag()
{
    //dtor
}

Motion SensorTag::getMotion() {


    uint8_t *buff = new uint8_t[12];
    this->readMotion(buff);

    return this->convertMotion(buff);

}

int SensorTag::readMotion(uint8_t * buffer) {

    uint8_t buff [12] = {0x0d, 0x01, 0x6c, 0xfc, 0xd9, 0xfc, 0xf4, 0xfd, 0x85, 0x00, 0xd2, 0x0f};
    memcpy(buffer, buff, 12);

}

Motion SensorTag::convertMotion(uint8_t * rawData) {

    Motion a;

    int16_t *gyro_x = (int16_t*) (rawData+0);
    int16_t *gyro_y = (int16_t*) (rawData+2);
    int16_t *gyro_z = (int16_t*) (rawData+4);

    int16_t *acc_x = (int16_t*) (rawData+6);
    int16_t *acc_y = (int16_t*) (rawData+8);
    int16_t *acc_z = (int16_t*) (rawData+10);


    a.gyro.x = (*gyro_x * 1.0) / (65536 / 500);
    a.gyro.y = (*gyro_y * 1.0) / (65536 / 500);
    a.gyro.z = (*gyro_z * 1.0) / (65536 / 500);

    a.acc.x = (*acc_x * 1.0) / (65536 / 4);
    a.acc.y = (*acc_y * 1.0) / (65536 / 4);
    a.acc.z = (*acc_z * 1.0) / (65536 / 4);

    return a;

}
